%include "win32n.inc"
%include "macros.inc"

EXTERN LoadMenuA
EXTERN InsertMenuA
EXTERN CloseHandle
EXTERN LoadLibraryA
EXTERN GetProcAddress
EXTERN GetModuleHandleA
EXTERN GetMenu
EXTERN ShowWindow
EXTERN GetMenuItemCount
EXTERN GetMenuItemInfoA
EXTERN GetLastError
EXTERN ShellAboutA

GLOBAL EntryPoint
GLOBAL DllEntryPoint
GLOBAL ExtractIcon
GLOBAL ItemInserter
GLOBAL MyMenuItemHandlerFunction
GLOBAL ShellAbout

EXPORT DllEntryPoint
EXPORT ExtractIcon ExtractIconA
EXPORT ShellAbout ShellAboutA
EXPORT ItemInserter
EXPORT MyMenuItemHandlerFunction

;====================

EntryPoint:
BSP_PROC        ; see 'macros.inc'
proc DllEntryPoint, handle, reason, reserved
    cmp .reason, DLL_PROCESS_ATTACH
    jne .finish
    mov [00403000h], dword MyMenuItemHandlerFunction     ; Save address of MMIHF in var (see tut)
    mov [00403004h], dword ItemInserter                  ; same with II
.finish:
    mov eax, 1
endproc

;====================

proc ExtractIcon, hInst, fileName, iconIndex             ; fakes API-call
[section .data]
BITS 32
    .shell32    db 'Shell32',0
    .EIA        db 'ExtractIconA',0

[section .text]
BITS 32
    stdcall LoadLibraryA, .shell32
    stdcall GetProcAddress, eax, .EIA
    stdcall eax, [.hInst], [.fileName], [.iconIndex]
endproc

;====================

proc ShellAbout, hWnd, szApp, szOtherStuff, hIcon          ; fakes API-call
[section .data]
BITS 32

    .shell32    db 'Shell32',0
    .SAA        db 'ShellAboutA',0

[section .text]
BITS 32
    stdcall LoadLibraryA, .shell32
    stdcall GetProcAddress, eax, .SAA
    stdcall eax, [.hWnd], [.szApp], [.szOtherStuff], [.hIcon]
endproc

;====================

proc ItemInserter, hWnd, nCmdShow                   ; replacement for ShowWindow
[section .data]
BITS 32
    .menuName    db 'CaptREsReMeMenu',0
    
    .itemName   dd '&Detour',0

[section .bss]
BITS 32
    .menuHndl   resd 1

[section .text]
BITS 32
    stdcall GetMenu, [.hWnd]
    mov [.menuHndl], eax
    stdcall InsertMenuA, [.menuHndl], 0FFFFFFFFh, MF_BYPOSITION | MF_STRING, 3, .itemName
    stdcall ShowWindow, [.hWnd], [.nCmdShow]
endproc

;====================

proc MyMenuItemHandlerFunction, icon                ; Handle 'detour'
[section .data]
BITS 32
    .shell32    db 'Shell32',0
    .path       db '',0

[section .text]
BITS 32
    stdcall LoadLibraryA, .shell32
    stdcall GetProcAddress, eax, 3Dh
    stdcall eax, 0, [.icon], [.path], 0, 0, 0ah     ; 0ah = NO_DEFAULT_STRING | SOMETHING_I_DONT_REMEMBER
endproc