.386
.model flat,stdcall
option casemap:none
include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\gdi32.inc
include hooker.inc ;the include functions prototypes
includelib hooker.lib 
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\gdi32.lib

.const
IDD_MAINDLG                     equ 101
IDC_CLASSNAME                   equ 1000
IDC_HANDLE                      equ 1001
IDC_WNDPROC                     equ 1002
IDC_HOOK                        equ 1004
IDC_EXIT                        equ 1005
BitmapProc proto

DlgFunc PROTO :DWORD,:DWORD,:DWORD,:DWORD

.data
HookText db "&Hook",0
UnhookText db "&Unhook",0
HookFlag dd FALSE ;flag indicating whether hooked atm or not
template db "%lx",0
ClassName db "SPLASHCLASS",0
hBitMap dd 0 
TimerID dd 0 
BitmapName db "Splash",0

.data?
hInstance dd ?
hHook dd ?

.code
start:
	invoke GetModuleHandle,NULL
	mov hInstance,eax
	invoke DialogBoxParam,hInstance,IDD_MAINDLG,NULL,addr DlgFunc,NULL
	invoke ExitProcess,NULL

DlgFunc proc hDlg:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
	LOCAL rect:RECT
	.if uMsg==WM_CLOSE ; if the user closes our hooker
		.if HookFlag==TRUE
			invoke UninstallHook ;uninstall the hook
		.endif
		invoke EndDialog,hDlg,NULL
	.elseif uMsg==WM_INITDIALOG
		invoke GetWindowRect,hDlg,addr rect
		invoke SetWindowPos,hDlg,HWND_TOPMOST,rect.left,rect.top,rect.right,rect.bottom,SWP_SHOWWINDOW
        .elseif uMsg==500 ;if the message is our custom-chosen 500
    	        invoke BitmapProc ;show the splashscreen
				  ;taken from Iczelion's asm tutorial #26, check it out
	.elseif uMsg==WM_COMMAND
		.if lParam!=0
			mov eax,wParam
			mov edx,eax
			shr edx,16
			.if dx==BN_CLICKED ;if it's a button click
				.if ax==IDC_EXIT
					invoke SendMessage,hDlg,WM_CLOSE,0,0
				.else ;it's the hook/unhook button
					.if HookFlag==FALSE ;if it was hook
                	                        invoke InstallHook,hDlg ;instalhook
						.if eax!=NULL
							mov HookFlag,TRUE
							invoke SetDlgItemText,hDlg,IDC_HOOK,addr UnhookText ;set the text of the button to 'Unhook'
						.endif
					.else ;if it was unhook
						invoke UninstallHook ;uninstall the hook
						mov HookFlag,FALSE
						invoke SetDlgItemText,hDlg,IDC_HOOK,addr HookText
        				.endif
				.endif
			.endif
		.endif
	.else
		mov eax,FALSE
		ret
	.endif
	mov eax,TRUE
	ret
DlgFunc endp

BitmapProc proc
LOCAL wc:WNDCLASSEX 
LOCAL msg:MSG 
LOCAL hwnd:HWND 

	mov wc.cbSize,SIZEOF WNDCLASSEX 
	mov wc.style, CS_HREDRAW or CS_VREDRAW 
	mov wc.lpfnWndProc, OFFSET WndProc 
	mov wc.cbClsExtra,NULL 
	mov wc.cbWndExtra,NULL 
	push hInstance 
	pop wc.hInstance 
	mov wc.hbrBackground,COLOR_WINDOW+1 
	mov wc.lpszMenuName,NULL 
	mov wc.lpszClassName,OFFSET ClassName 
	invoke LoadIcon,NULL,IDI_APPLICATION 
	mov wc.hIcon,eax 
	mov wc.hIconSm,0 
	invoke LoadCursor,NULL,IDC_ARROW 
	mov wc.hCursor,eax 
	invoke RegisterClassEx, addr wc 
	;create a new window with dimensions 530x160(size of bitmap)
	INVOKE CreateWindowEx,NULL,ADDR ClassName,NULL,WS_POPUP+WS_EX_TOPMOST,CW_USEDEFAULT,\
                              CW_USEDEFAULT,530,160,NULL,NULL,hInstance,NULL 
	mov hwnd,eax 
	INVOKE ShowWindow, hwnd,SW_SHOWNORMAL 
	.WHILE TRUE 
		INVOKE GetMessage, ADDR msg,NULL,0,0 
		.BREAK .IF (!eax) 
		INVOKE TranslateMessage, ADDR msg 
		INVOKE DispatchMessage, ADDR msg 
	.ENDW 
	mov eax,msg.wParam 
ret 
BitmapProc endp

WndProc proc hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD 
LOCAL ps:PAINTSTRUCT 
LOCAL hdc:HDC 
LOCAL hMemoryDC:HDC 
LOCAL hOldBmp:DWORD 
LOCAL bitmap:BITMAP 
LOCAL DlgHeight:DWORD 
LOCAL DlgWidth:DWORD 
LOCAL DlgRect:RECT 
LOCAL DesktopRect:RECT 

	.if uMsg==WM_DESTROY 
		.if hBitMap!=0 
			invoke DeleteObject,hBitMap 
		.endif 
		invoke PostQuitMessage,NULL 
	.elseif uMsg==WM_CREATE 
		invoke GetWindowRect,hWnd,addr DlgRect 
		invoke GetDesktopWindow 
		mov ecx,eax 
		invoke GetWindowRect,ecx,addr DesktopRect 
		push 0 
		mov eax,DlgRect.bottom 
		sub eax,DlgRect.top 
		mov DlgHeight,eax 
		push eax 
		mov eax,DlgRect.right 
		sub eax,DlgRect.left 
		mov DlgWidth,eax 
		push eax 
		mov eax,DesktopRect.bottom 
		sub eax,DlgHeight 
		shr eax,1 
		mov DlgRect.top,eax
		push eax 
		mov eax,DesktopRect.right 
		sub eax,DlgWidth 
		shr eax,1
		mov DlgRect.left,eax 
		push eax 
		push hWnd 
		call MoveWindow
		;set the splashscreen window always on top
		invoke SetWindowPos,hWnd,HWND_TOPMOST,DlgRect.left,DlgRect.top,DlgWidth,DlgHeight,SWP_SHOWWINDOW
		invoke GetWindowRect,hWnd,addr DlgRect 
		invoke LoadBitmap,hInstance,addr BitmapName 
		mov hBitMap,eax 
		invoke SetTimer,hWnd,1,2000,NULL 
		mov TimerID,eax 
	.elseif uMsg==WM_TIMER 
		invoke SendMessage,hWnd,WM_LBUTTONDOWN,NULL,NULL 
		invoke KillTimer,hWnd,TimerID 
	.elseif uMsg==WM_PAINT 
		invoke BeginPaint,hWnd,addr ps 
		mov hdc,eax 
		invoke CreateCompatibleDC,hdc 
		mov hMemoryDC,eax 
		invoke SelectObject,eax,hBitMap 
		mov hOldBmp,eax 
		invoke GetObject,hBitMap,sizeof BITMAP,addr bitmap 
		invoke StretchBlt,hdc,0,0,530,160,hMemoryDC,0,0,530,160,SRCCOPY 
		invoke SelectObject,hMemoryDC,hOldBmp 
		invoke DeleteDC,hMemoryDC 
		invoke EndPaint,hWnd,addr ps 
	.elseif uMsg==WM_LBUTTONDOWN 
		invoke DestroyWindow,hWnd 
	.else 
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam 
		ret 
	.endif 
	xor eax,eax 
ret 
WndProc endp 

end start